package com.blamejared.compat.botania.handlers;

import vazkii.botania.api.BotaniaAPI;
import crafttweaker.IAction;
import stanhebben.zenscript.annotations.ZenMethod;
import com.blamejared.ModTweaker;
import crafttweaker.api.oredict.IOreDictEntry;
import crafttweaker.annotations.ZenRegister;
import crafttweaker.annotations.ModOnly;
import stanhebben.zenscript.annotations.ZenClass;

@ZenClass("mods.botania.OrechidIgnem")
@ModOnly("botania")
@ZenRegister
public class OrechidIgnem
{
    @ZenMethod
    public static void addOre(final IOreDictEntry oreDict, final int weight) {
        ModTweaker.LATE_ADDITIONS.add(new Add(oreDict.getName(), weight));
    }
    
    @ZenMethod
    public static void addOre(final String oreDict, final int weight) {
        ModTweaker.LATE_ADDITIONS.add(new Add(oreDict, weight));
    }
    
    @ZenMethod
    public static void removeOre(final IOreDictEntry oreDict) {
        ModTweaker.LATE_REMOVALS.add(new Remove(oreDict.getName()));
    }
    
    @ZenMethod
    public static void removeOre(final String oreDict) {
        ModTweaker.LATE_REMOVALS.add(new Remove(oreDict));
    }
    
    private static class Add implements IAction
    {
        String oreDict;
        int weight;
        
        public Add(final String ore, final int prop) {
            this.oreDict = ore;
            this.weight = prop;
        }
        
        public void apply() {
            BotaniaAPI.addOreWeightNether(this.oreDict, this.weight);
        }
        
        public String describe() {
            return "Adding OrechidIgnem Ore Weight: " + this.oreDict + ":" + this.weight;
        }
    }
    
    private static class Remove implements IAction
    {
        String oreDict;
        
        public Remove(final String ore) {
            this.oreDict = ore;
        }
        
        public void apply() {
            BotaniaAPI.oreWeightsNether.remove(this.oreDict);
        }
        
        public String describe() {
            return "Removing Orechid Ore: " + this.oreDict;
        }
    }
}
